unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus,About,Begin_;

  const S_GAME=0;const S_WIN=1; const S_LOSE=2; const S_NONE=3;
  const MAX=4;

type
  TMainfrm = class(TForm)
    MainMenu: TMainMenu;
    N1: TMenuItem;
    NewGamemi: TMenuItem;
    Exitmi: TMenuItem;
    N2: TMenuItem;
    About: TMenuItem;
    procedure AboutClick(Sender: TObject);
    procedure ExitmiClick(Sender: TObject);
    procedure NewGamemiClick(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormActivate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Mainfrm: TMainfrm;
  Situation: integer;
  Scene:array [1..MAX,1..MAX] of integer;
  Sector_SizeX:integer;
  Sector_SizeY:integer;
  FontSize:integer;
  StepCount:integer;
implementation

procedure SetMainfrmCaption();
var str1:string;
begin
  str1:=' 15. : '+IntToStr(StepCount);
  Mainfrm.Caption:=str1;
end;

{$R *.dfm}
procedure MyMouseDown(X, Y: Integer);
var n,m,sx,sy:integer;

begin

  n:=Trunc(x / Sector_SizeX)+1;
  m:=Trunc(y/Sector_SizeY)+1;
  if (n>MAX) Then n:=MAX;
  if (m>MAX) Then m:=MAX;
  sx:=n; sy:=m;
  if (n>1) then

  begin
    if (Scene[n-1,m]=0) then   sx:=n-1;
  end;
  if (n<MAX) then
  begin
    if (scene[n+1,m]=0) then sx:=n+1;
  end;
  if (m>1) then
  begin
    if (Scene[n,m-1]=0) then   sy:=m-1;
  end;
  if (m<MAX) then
  begin
    if (scene[n,m+1]=0) then sy:=m+1;
  end;
  if ((sx=n) and (sy=m)) then
  else
  begin

    scene[sx,sy]:=scene[n,m];
    scene[n,m]:=0;
    Inc(StepCount);
    SetMainfrmCaption();
  end;

end;


procedure TMainfrm.AboutClick(Sender: TObject);
begin
       AboutBox.ShowModal
end;

procedure TMainfrm.ExitmiClick(Sender: TObject);
begin
  Mainfrm.Close 
end;

procedure TMainfrm.NewGamemiClick(Sender: TObject);
var n:integer;
begin

  For n:=1 to 1000 do
  begin
     MyMouseDown(Random(Mainfrm.ClientWidth-1),Random(Mainfrm.ClientHeight-1));
  end;
  StepCount:=0;
  SetMainfrmCaption();
  Mainfrm.Paint();
end;

procedure TMainfrm.FormPaint(Sender: TObject);
var n,m:integer;
var  str1:string;
begin
  Mainfrm.Canvas.Pen.Color:=RGB(0,255,0);
  Mainfrm.Canvas.Font.Color:=RGB(0,255,0);
  Mainfrm.Canvas.Brush.Color:=RGB(0,0,0);
  for n:=1 to MAX do
  begin
    for m:=1 to MAX do
    begin
      //if (Scene[n,m]<>0) then Mainfrm.Canvas.Brush.Color:=RGB(0,255,0)
      //else Mainfrm.Canvas.Brush.Color:=RGB(255,255,255);

      Mainfrm.canvas.Rectangle((n-1)*Sector_SizeX,(m-1)*Sector_SizeY,(n-1)*Sector_SizeX+Sector_SizeX,(m-1)*Sector_SizeY+Sector_SizeY);
      str1:=IntToStr(Scene[n,m]);
      if (Scene[n,m]=0) then  str1:=' ';

      Mainfrm.Canvas.TextOut((n-1)*Sector_SizeX+Round(Sector_SizeX/2)-Round(Mainfrm.Canvas.TextWidth(str1)/2 ),(m-1)*Sector_SizeY+Round(Sector_SizeY/2)-Round(Mainfrm.Canvas.TextHeight(str1)/2) ,str1);
   end;
  end;
end;

procedure TMainfrm.FormCreate(Sender: TObject);
var n,x,y:integer;
//    st:TShiftState;
begin
  
  Sector_sizeX:=Trunc((Mainfrm.ClientWidth)/ MAX) ;
  Sector_SizeY:=Trunc((Mainfrm.ClientHeight)/(MAX));
  randomize;
  Situation:=S_GAME;
  Mainfrm.Paint ;
  x:=-1; y:=-1;
  for n:=1 to 15 do
  begin

      x:=(x+1) mod (MAX);
      if (x=0)  then y:=(y+1) mod (MAX);

    scene[x+1,y+1]:=n;
  end;
 Mainfrm.NewGamemiClick(Mainfrm) ;
end;

procedure TMainfrm.FormResize(Sender: TObject);
//var n,m:integer;
begin
  Sector_sizeX:=Trunc((Mainfrm.ClientWidth)/ MAX) ;
  Sector_SizeY:=Trunc((Mainfrm.ClientHeight)/(MAX));
  if (Sector_SizeX<Sector_SizeY) then  FontSize:=Round(Sector_SizeX/2)
  else FontSize:=Round(Sector_SizeY/2);
  Mainfrm.Canvas.Font.Size :=Round(FontSize);
  Mainfrm.Paint;

end;


procedure TMainfrm.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var n,m,k:integer;
    yes:boolean;
begin
   if (Situation=S_GAME) then    MyMouseDown(x,y);
   k:=0;
   yes:=TRUE;
   n:=1; 
   while (n<=MAX) do
   begin
   m:=1;
     while (m<=MAX) do
     begin
       k:=k+1;
       if (n=MAX) and (m=MAX) then break;
       if (scene[m,n]<>k) then yes:=FALSE;
       m:=m+1;
     end;
     n:=n+1;
   end;
   if (yes=TRUE ) then
   begin
     MessageBox(Mainfrm.ClientHandle,'!!!      !','',MB_OK);
     Situation:=S_WIN;
   end;
   Mainfrm.Paint;
end;

procedure TMainfrm.FormActivate(Sender: TObject);
begin
  Beginfrm.ShowModal ;
  Mainfrm.Paint ;
end;

procedure TMainfrm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var n,m:integer;
begin

  for n:=1 to MAX do
  begin
    for m:=1 to MAX do
    begin
      if (scene[n,m]=0) then break;
    end;
    if (m<=MAX) and (scene[n,m]=0) then break;
  end;
  case (Key) of
  VK_LEFT: begin
             if (n-1>=0) then
             MyMouseDown((n-2)*Sector_SizeX+1,(m-1)*Sector_SizeY+1);
            // mainfrm.Canvas.Rectangle((n-1)*Sector_SizeX,m*Sector_SizeY,(n-1)*Sector_SizeX+3,m*Sector_SizeY+3) ;
           end;
  VK_RIGHT: begin
            if (n+1<=MAX) then
             MyMouseDown((n)*Sector_SizeX+1,(m-1)*Sector_SizeY+1);

            end;
  VK_UP:    begin
            if (m-1>=0) then
             MyMouseDown((n-1)*Sector_SizeX+1,(m-2)*Sector_SizeY+1);
            end;
  VK_DOWN:  begin
             if (m+1<=MAX) then
             MyMouseDown((n-1)*Sector_SizeX+1,(m)*Sector_SizeY+1);
            end;

  end;
  Mainfrm.Paint;
end;


end.




